// Licensed under the Creative-commons cc by 4.0
// see https://creativecommons.org/licenses/by/4.0/
// feel free to modify this code and add your Name to this line.
// ...


desc: VMeter 1.28 Control-Unit 1.0 (Markus Fiedler)
slider1:1<1,16,1>VMeter Send MIDI Channel
slider2:20<0,100,1>Position Output MIDI Controller Number
slider3:21<0,100,1>Change On/Off Output Ctrl Num
slider4:22<0,100,1>Change Pressure Output Ctrl Num
slider5:20<0,100,1>Change Light Input Ctrl Num
slider6:19<0,100,1>Change Brightness Input Ctrl Num
slider7:20<0,127,1>Change Noteout Number
slider8:110<0,127,1>Change Noteout Velocity
slider9:0<0,1,1{Upside-down mode off,Upside-down mode on}>Upside-down mode
slider10:1<0,1,1{Touch Position Output off,Touch Position Output on}>Touch Position Output
slider11:0<0,1,1{Pressure Output off,Pressure Output on}>Pressure Output
slider12:0<0,1,1{Note On/Off Messages off,Note On/Off Messages on}>Note On/Off Messages
slider13:0<0,1,1{Pitch Wheel Mode off,Pitch Wheel Mode on}>Pitch Wheel Mode
slider14:0<0,1,1{Crossfader Mode off,Crossfader Mode on}>Crossfader Mode
slider15:0<0,1,1{Note out Velocity Mode Default,Note out Velocity Mode Position}>Note out Velocity Mode (Position / Default)
slider16:0<0,1,1{Note out Pitch Mode off,Note out Pitch Mode on}>Note out Pitch Mode
slider17:0<0,1,1{Lights ignore Touch off,Lights ignore Touch on}>Lights ignore Touch
slider18:0<0,1,1{Transfer all off,Transfer all on}>Transfer all VMeter 1.28 Control-Unit setting

@init
// Funktion zum Senden von MIDI-CC (vor Aufruf definiert)
function send_midi_cc(ctrl_num, value)
(
  midisend(0, midi_channel, ctrl_num, value);
);

// MIDI-Kanal 1 (0xB0 = CC auf Kanal 1)
midi_channel = 0xB0;

// Initialisierung der vorherigen Werte für Änderungsprüfung
prev_slider1 = slider1;
prev_slider2 = slider2;
prev_slider3 = slider3;
prev_slider4 = slider4;
prev_slider5 = slider5;
prev_slider6 = slider6;
prev_slider7 = slider7;
prev_slider8 = slider8;
prev_slider9 = slider9;
prev_slider10 = slider10;
prev_slider11 = slider11;
prev_slider12 = slider12;
prev_slider13 = slider13;
prev_slider14 = slider14;
prev_slider15 = slider15;
prev_slider16 = slider16;
prev_slider17 = slider17;
prev_slider18 = slider18;

// Initiale Übertragung der Default-Werte für Schalter mit Default-Werten != 0
send_midi_cc(119, slider10 ? 124 : 123); // Touch Position Output (Default: 124)

@block
// Funktion zum Senden aller aktuellen Werte
function send_all_values()
(
  send_midi_cc(117, slider1);
  send_midi_cc(116, slider2);
  send_midi_cc(115, slider3);
  send_midi_cc(114, slider4);
  send_midi_cc(113, slider5);
  send_midi_cc(112, slider6);
  send_midi_cc(111, slider7);
  send_midi_cc(110, slider8);
  send_midi_cc(119, slider9 ? 125 : 126);
  send_midi_cc(119, slider10 ? 124 : 123);
  send_midi_cc(119, slider11 ? 122 : 121);
  send_midi_cc(119, slider12 ? 117 : 116);
  send_midi_cc(119, slider13 ? 115 : 114);
  send_midi_cc(119, slider14 ? 105 : 104);
  send_midi_cc(119, slider15 ? 111 : 110);
  send_midi_cc(119, slider16 ? 109 : 108);
  send_midi_cc(119, slider17 ? 107 : 106);
);

// Prüfung, ob "Transfer all" aktiviert wird
slider18 != prev_slider18 && slider18 == 1 ? (
  send_all_values();
  prev_slider18 = slider18;
);

// Fader 1: VMeter Send MIDI Channel
slider1 != prev_slider1 ? (
  slider18 ? send_all_values() : send_midi_cc(117, slider1);
  prev_slider1 = slider1;
);

// Fader 2: Position Output MIDI Controller Number
slider2 != prev_slider2 ? (
  slider18 ? send_all_values() : send_midi_cc(116, slider2);
  prev_slider2 = slider2;
);

// Fader 3: Change On/Off Output Ctrl Num
slider3 != prev_slider3 ? (
  slider18 ? send_all_values() : send_midi_cc(115, slider3);
  prev_slider3 = slider3;
);

// Fader 4: Change Pressure Output Ctrl Num
slider4 != prev_slider4 ? (
  slider18 ? send_all_values() : send_midi_cc(114, slider4);
  prev_slider4 = slider4;
);

// Fader 5: Change Light Input Ctrl Num
slider5 != prev_slider5 ? (
  slider18 ? send_all_values() : send_midi_cc(113, slider5);
  prev_slider5 = slider5;
);

// Fader 6: Change Brightness Input Ctrl Num
slider6 != prev_slider6 ? (
  slider18 ? send_all_values() : send_midi_cc(112, slider6);
  prev_slider6 = slider6;
);

// Fader 7: Change Noteout Number
slider7 != prev_slider7 ? (
  slider18 ? send_all_values() : send_midi_cc(111, slider7);
  prev_slider7 = slider7;
);

// Fader 8: Change Noteout Velocity
slider8 != prev_slider8 ? (
  slider18 ? send_all_values() : send_midi_cc(110, slider8);
  prev_slider8 = slider8;
);

// Schalter 1: Upside-down mode
slider9 != prev_slider9 ? (
  slider18 ? send_all_values() : send_midi_cc(119, slider9 ? 125 : 126);
  prev_slider9 = slider9;
);

// Schalter 2: Touch Position Output
slider10 != prev_slider10 ? (
  slider18 ? send_all_values() : send_midi_cc(119, slider10 ? 124 : 123);
  prev_slider10 = slider10;
);

// Schalter 3: Pressure Output
slider11 != prev_slider11 ? (
  slider18 ? send_all_values() : send_midi_cc(119, slider11 ? 122 : 121);
  prev_slider11 = slider11;
);

// Schalter 4: Note On/Off Messages
slider12 != prev_slider12 ? (
  slider18 ? send_all_values() : send_midi_cc(119, slider12 ? 117 : 116);
  prev_slider12 = slider12;
);

// Schalter 5: Pitch Wheel Mode
slider13 != prev_slider13 ? (
  slider18 ? send_all_values() : send_midi_cc(119, slider13 ? 115 : 114);
  prev_slider13 = slider13;
);

// Schalter 6: Crossfader Mode
slider14 != prev_slider14 ? (
  slider18 ? send_all_values() : send_midi_cc(119, slider14 ? 105 : 104);
  prev_slider14 = slider14;
);

// Schalter 7: Note out Velocity Mode
slider15 != prev_slider15 ? (
  slider18 ? send_all_values() : send_midi_cc(119, slider15 ? 111 : 110);
  prev_slider15 = slider15;
);

// Schalter 8: Note out Pitch Mode
slider16 != prev_slider16 ? (
  slider18 ? send_all_values() : send_midi_cc(119, slider16 ? 109 : 108);
  prev_slider16 = slider16;
);

// Schalter 9: Lights ignore Touch
slider17 != prev_slider17 ? (
  slider18 ? send_all_values() : send_midi_cc(119, slider17 ? 107 : 106);
  prev_slider17 = slider17;
);

prev_slider18 = slider18;

//@gfx 400 600
//Setze den Titel in der GUI-Titelleiste
//gfx_setfont(1, "Arial", 20);
//gfx_x = 10; gfx_y = 10;
//gfx_drawstr("VMeter 1.28 Control-Unit (Markus Fiedler)");